package com.funambol.blackberry.controller;

import com.funambol.client.configuration.Configuration;
import com.funambol.syncml.protocol.DevInf;
import com.funambol.client.source.AppSyncSource;

import com.funambol.util.Log;

/**
 * TODO: Remove once the com.funambol.client.controller package integration is finished
 */
public class ProxyController extends com.funambol.client.controller.Controller {

    private static final String TAG_LOG = "ProxyController";

    private static ProxyController instance = null;

    private com.funambol.blackberry.controller.Controller actualController;

    private ProxyController(com.funambol.blackberry.controller.Controller actualController) {
        this.actualController = actualController;
    }

    public static ProxyController getInstance(com.funambol.blackberry.controller.Controller actualController) {
        if (instance == null) {
            instance = new ProxyController(actualController);
        }
        return instance;
    }

    public static ProxyController getInstance() {
        if (instance == null) {
            throw new IllegalArgumentException("Cannot create instance without controller");
        }
        return instance;
    }

    public void reapplyAccountConfiguration() {
        actualController.reapplyAccountConfiguration();
    }

    public void reapplyUpdaterConfiguration() {
        actualController.reapplyUpdaterConfiguration();
    }

    public void reapplySyncModeConfiguration() {
        actualController.reapplySyncModeConfiguration();
    }

    public void reapplyMiscConfiguration() {
        actualController.reapplyMiscConfiguration();
    }

    public void reapplyConfiguration() {
        actualController.reapplyConfiguration();
    }

    public void reapplySourceConfiguration(AppSyncSource appSource) {
        actualController.reapplySourceConfiguration(appSource);
    }

    public void reapplyServerCaps(DevInf devInf) {
        actualController.reapplyServerCaps(devInf);
    }

    public void toBackground() {
        actualController.toBackground();
    }

    public void toForeground() {
        actualController.toForeground();
    }

    public Configuration getConfiguration() {
        return actualController.getConfiguration();
    }

    public boolean checkForUpdate() {
        return actualController.checkForUpdate();
    }

    public boolean isVisible(AppSyncSource appSource) {
        return actualController.isVisible(appSource);
    }
}

